# -*- coding: utf-8 -*-
"""
Created on Fri Apr  3 18:31:25 2020

@author: estefania.heredia
"""
import pandas as pd
from sqlalchemy import create_engine
#import numpy as np
import functionsDB
import preprocessingData
import calcVar3
import finalData2
import predictRF3
import analizeData2
import get_infoCarrera
from settings import RETENTION_VAL

print("Conectando a la BD\n")
conn = functionsDB.connect_DB()

estudiantes, historial = functionsDB.download(conn)
print("Archivos descargados de BD\n")

cambioEstudiante, cambioHistorial, carreras = preprocessingData.preprocessingDataAcademica(estudiantes, historial)
print("Termino el preprocesamiento de la data")

numEstudXCarrera = cambioEstudiante.groupby(["codDegree"]).size().to_frame()

####Número de materias tomadas por semestres y por anio que lleva cursando cada alumno
asigxSem = cambioHistorial.groupby(["id", "codDegree", "year", "semesterNum"]).size().to_frame()

####Número de semestres tomados cada alumno
alumSem = asigxSem.groupby(["id", "codDegree"]).count()
alumSem.columns = ["Semestres"]

###Cogemos los estudiantes con su primer semestre academico ordinario
cambioHistorial1Sem = cambioHistorial[(cambioHistorial['numTermino'] == 1)]
alum1Sem = alumSem[alumSem['Semestres'] == 1]

##Cogemos los estudiantes con su primer y segundo semestre academico ordinario
cambioHistorial2Sem = cambioHistorial[(cambioHistorial['numTermino'] == 2)]
cambioHistorial12Sem = pd.concat([cambioHistorial1Sem, cambioHistorial2Sem], ignore_index=True)
cambioHistorial12Sem = cambioHistorial12Sem.sort_values(["id", "codDegree", "year", "semesterNum"], ascending=[True, True, True, True])
alum2Sem = alumSem[alumSem['Semestres'] == 2]

##Cogemos los estudiantes con su Primer, segundo y tercer semestre academico ordinario
cambioHistorial3Sem = cambioHistorial[(cambioHistorial['numTermino'] == 3)]
cambioHistorial123Sem = pd.concat([cambioHistorial12Sem, cambioHistorial3Sem], ignore_index=True)
cambioHistorial123Sem = cambioHistorial123Sem.sort_values(["id", "codDegree", "year", "semesterNum"], ascending=[True, True, True, True])
alum3Sem = alumSem[alumSem['Semestres'] == 3]

##Cogemos los estudiantes con su Primer, segundo, tercer y cuarto semestre academico ordinario
cambioHistorial4Sem = cambioHistorial[(cambioHistorial['numTermino'] == 4)]
cambioHistorial1234Sem = pd.concat([cambioHistorial123Sem, cambioHistorial4Sem], ignore_index=True)
cambioHistorial1234Sem = cambioHistorial1234Sem.sort_values(["id", "codDegree", "year", "semesterNum"], ascending=[True, True, True, True])
alum4Sem = alumSem[alumSem['Semestres'] == 4]

##Cogemos los estudiantes con su Primer, segundo, tercer, cuarto y quinto semestre academico ordinario
cambioHistorial5Sem = cambioHistorial[(cambioHistorial['numTermino'] == 5)]
cambioHistorial12345Sem = pd.concat([cambioHistorial1234Sem, cambioHistorial5Sem], ignore_index=True)
cambioHistorial12345Sem = cambioHistorial12345Sem.sort_values(["id", "codDegree", "year", "semesterNum"], ascending=[True, True, True, True])
alum5Sem = alumSem[alumSem['Semestres'] == 5]

#Alumnos a partir de sexto semestre
cambioHistorialMas5Sem = cambioHistorial.copy()
cambioHistorialMas5Sem = cambioHistorialMas5Sem.sort_values(["id", "codDegree", "year", "semesterNum"], ascending=[True, True, True, True])
alumMas5Sem = alumSem[alumSem['Semestres'] > 5]

infoDegree = {}
numEstDegree = {}
resultados = {}
featureSelection = {}
metricas = {}

datosBD = pd.DataFrame()
weightsBD = pd.DataFrame()

pesos = {}
typeInterpreter = "shap"
classConsider = RETENTION_VAL

if typeInterpreter == 'shap':
    classNames = ['stateStudent']
else: #lime
    classNames = ['no dropout', 'dropout']

i=5
for i in range(6):
    if i == 0:
        historialSemestre = cambioHistorial1Sem
        alumnosSemestre = alum1Sem

    elif i == 1:
        historialSemestre = cambioHistorial12Sem
        alumnosSemestre = alum2Sem

    elif i == 2:
        historialSemestre = cambioHistorial123Sem
        alumnosSemestre = alum3Sem

    elif i == 3:
        historialSemestre = cambioHistorial1234Sem
        alumnosSemestre = alum4Sem

    elif i == 4:
        historialSemestre = cambioHistorial12345Sem
        alumnosSemestre = alum5Sem

    elif i == 5:
        historialSemestre = cambioHistorialMas5Sem
        alumnosSemestre = alumMas5Sem

    print("Semestre: ", i+1)

    infoEstud, dataMediaNotas, dataCreditos = calcVar3.calcular(historialSemestre)
    print("Variables de entrada calculadas\n")

    final = finalData2.finalData(infoEstud, cambioEstudiante, dataMediaNotas, dataCreditos)
    print("Datos finales listos\n")


    ##########################################################    
    # "LI002" Economía , "CI007" Mecánica, CI013 Computaacion"
    #  "CI001" Industrial ,  CI005" CI005"
    for carrera in carreras['degree']:
        print("\n#####################################################################\n")
        #carrera = "CI001"

        dataCarrera = final[final.degree == carrera]
        print('We have {} students of data with {} variables for the degree {}'.format(*dataCarrera.shape, carrera))

        numEstTot = dataCarrera.shape[0]
        numEstA = dataCarrera[dataCarrera.dropout == 0].shape[0]
        numEstG = dataCarrera[dataCarrera.dropout == 1].shape[0]
        numEstP = dataCarrera[dataCarrera.dropout == -1].shape[0]

        numEst = pd.DataFrame([[numEstTot, numEstG, numEstA, numEstP]],
                              columns=["total", "graduados", "abandonados",
                                       "predecir"])

        numEstDegree[carrera + "Sem" +str(i+1)] = numEst
        #Necesito minimo el 15% de datos en graduados y abandonados para poder calcular
        min_data = 0.10

        if ((numEstP > (numEstG + numEstA) or numEstG > (numEstP * min_data) or numEstA > (numEstP * min_data))  and numEstG > 0 and numEstA > 0 and numEstP > 0):

            infoDegree[carrera + "Sem" +str(i+1)] = get_infoCarrera.getInfoDegree(dataCarrera)

            try:
                predictions, features, mets, weights = predictRF3.predict(dataCarrera, typeInterpreter, classNames, classConsider)
                resultados[carrera + "Sem" +str(i+1)] = predictions
                data2 = predictions.merge(alumnosSemestre, on='id', how='inner')
                datosBD = pd.concat([datosBD, data2], ignore_index=True)

                featureSelection[carrera + "Sem" +str(i+1)] = features

                metricas[carrera + "Sem" +str(i+1)] = mets

                pesos[carrera + "Sem" +str(i+1)] = weights
                finalWeights2 = weights.merge(alumnosSemestre, on='id', how='inner')
                weightsBD = pd.concat([weightsBD, finalWeights2], ignore_index=True)

            except:
                print("Error, no se puede predecir para esta carrera " + carrera +" en este semesetre "+ str(i+1))
                resultados[carrera + "Sem" +str(i+1)] = -1
                featureSelection[carrera + "" +str(i+1)] = -1
                metricas[carrera + "Sem" +str(i+1)] = -1
                pesos[carrera + "Sem" +str(i+1)] = -1
                final1 = final.merge(alumnosSemestre, on='id', how='inner')
        else:
            print("Error, no hay suficientes datos para esta carrera " + carrera +" en este semesetre "+ str(i+1))

        print("\n#####################################################################\n")


datosBD = datosBD.drop_duplicates(subset='id', keep='first')
print("Predicción acabada.")

datosBDSoloEstAct = datosBD[(datosBD['stateStudent'] == "")]
weightsBDEstAct = weightsBD[weightsBD.id.isin(datosBDSoloEstAct.id)]
datosBD = datosBDSoloEstAct
weightsBD = weightsBDEstAct

dataBase, percentilesDB = analizeData2.analizeDataPredicted(datosBD, weightsBD, infoDegree, metricas)

results_prediction = dataBase[['id', 'dropout', 'frase']]
results_prediction.columns = ['id', 'stateStudent', 'frase']


print("Subimos resultados a la base de datos")
functionsDB.upload_PredictionsResults(results_prediction)

if conn:
    conn.close()
    print("PostgreSQL connection is closed")

print("Fin!!!!")
