"""
Created on Thu Jan  28 11:11:34 2020

@author: estefania.heredia
"""
from datetime import datetime
import psycopg2
import pandas as pd
import numpy as np

def download():
    """This module preprocess the student data from DB, normalizes and selects the columns to use

    Parameters:
    estudiantes (dataframe): Description of arg1

    Returns:
    df (dataframe): Returning value

    """
    startTime = datetime.now()

    try:
        conn = psycopg2.connect(database='lala_uc3m', user='lala_usr',
                                password='0t3H@hG&', host='200.10.150.52')
    
        cur = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    
        print("Bajando datos de estudiantes")
        cur.execute("SELECT * FROM dim_estudiante ORDER BY id")
        data = cur.fetchall()
        df = pd.DataFrame(np.array(data), columns=data[0].keys())
    
        print("Bajando historiales de estudiantes")
        cur.execute("SELECT * FROM dim_historial_estudiante ORDER BY id")
        data = cur.fetchall()
        df1 = pd.DataFrame(np.array(data), columns=data[0].keys())

    except (psycopg2.Error) as error:
        print ("Error while inserting to PostgreSQL: ", error)

    finally:
        if conn:
            cur.close()

    print(datetime.now() - startTime)

    return df, df1
