# -*- coding: utf-8 -*-
"""
Created on Thu Apr  9 10:30:52 2020

@author: estefania.heredia
"""
from datetime import datetime
# -*- coding: utf-8 -*-
import pandas as pd
import numpy as np
from settings import DROPOUT_VAL, RETENTION_VAL

#    #Datos de # d materias, 2da y 3era matricula
#    #Datos de los estudiantes
#    #Datos de las diferentes medias que hemos sacado anteriormente
#    #Datos de los creditos tasas
def finalData(infoEstud, cambioEstudiante, dataMediaNotas, dataCreditos):
    """
    Created on Thu Apr  9 10:30:31 2020

    @author: estefania.heredia
    """
    startTime = datetime.now()

    data = pd.merge(cambioEstudiante, infoEstud, how='outer', on=['id', 'codDegree'])
    data = pd.merge(data, dataMediaNotas, how='outer', on=['id', 'codDegree'])
    data = pd.merge(data, dataCreditos, how='outer', on=['id', 'codDegree'])
    data = data.fillna(0)

    #Porcentaje de creditos aprobados del total
    data["credDoneRate"] = data.creditosDone/data.totCredits
    data["credDoneRate"].fillna(0, inplace=True)
    data["credDoneRate"] = round(data['credDoneRate'], 2)

    data['dropout'] = np.where((data['credDoneRate'] >= 0.90), RETENTION_VAL, data.dropout)

    data['mediaAPRPTomadas'] = np.where((((data['dropout'] == DROPOUT_VAL) | (data['dropout'] == RETENTION_VAL)) &
                                         (data['mediaAPRPTomadas'] == 0)),
                                        data.mediaAPRPTotal, data.mediaAPRPTomadas)


    ####################################################################
  	###comienzo a eliminar los datos que podrian causar ruido al modelo

    data = data.drop(data[(data['stateStudent'] == 'S')].index)
    #Significa que es la ultima oportunidad que tiene para aprobar la materia
    #sino dropout (esta cursando)
    #data['stateStudent'].replace("R","",inplace = True)

    data = data.drop(data[((data['mediaAPRPTotal'] == 0) & (data['mediaAPRPTomadas'] == 0))].index)

    data = data.drop(data[((data['ratePassFinal'] >= 0.95) & (data['dropout'] == DROPOUT_VAL))].index)

    dataG_A = data[((data['dropout'] == RETENTION_VAL) | (data['dropout'] == DROPOUT_VAL))]
    mediaAPRPDegreeTrain = dataG_A.groupby(['codDegree']).mediaAPRPTotal.sum().to_frame()/dataG_A.groupby(['codDegree']).mediaAPRPTotal.count().to_frame()
    ratePassFinalDegreeTrain = dataG_A.groupby(['codDegree']).ratePassFinal.sum().to_frame()/dataG_A.groupby(['codDegree']).ratePassFinal.count().to_frame()

    dataG_A['dropout'] = np.where(((dataG_A['ratePassFinal'] >= ratePassFinalDegreeTrain['ratePassFinal'].values[0]*1) &
                                   (dataG_A['dropout'] == DROPOUT_VAL) &
                                   (dataG_A['mediaAPRPTotal'] >= mediaAPRPDegreeTrain['mediaAPRPTotal'].values[0]*1)),
                                  3, dataG_A.dropout)

    dataG_ARest = dataG_A[(dataG_A['dropout'] == 3)]
    #elimando los estudiantes con dropout 3
    data = data[~(data.id.isin(dataG_ARest.id))]

    data = data.drop(data[((data['dropout'] == -1) & (data['mediaAPRPTomadas'] == 0))].index)

  	###termine de eliminar los datos que podrian causar ruido al modelo
    ####################################################################

    #reset d indices
    data = data.reset_index(drop=True)

    data['yearsNoStudy'] = np.where((data['dropout'] == RETENTION_VAL),
                                    data.gapSemestres, data.ultMat+data.gapSemestres)
    data['aniosUltMat2'] = np.where((data['dropout'] == RETENTION_VAL),
                                    0, data.ultMat)


    #Porcentaje de suspensos de cada carrera
    dataTot = data.groupby(('codDegree'), as_index=False).id.count()
    #dataTot.columns = ["codDegree", "materiasTotal"]

    dataFail = data[data.dropout == DROPOUT_VAL]
    dataFail = dataFail.groupby(('codDegree'), as_index=False).id.count()

    dataPass = data[data.dropout == RETENTION_VAL]
    dataPass = dataPass.groupby(('codDegree'), as_index=False).id.count()

    dataRate = pd.merge(dataTot, dataPass, how='outer', on=['codDegree'])
    dataRate = pd.merge(dataRate, dataFail, how='outer', on=['codDegree'])
    dataRate.fillna(0, inplace=True)
    dataRate.columns = ['codDegree', 'tot', 'Pass','fail']

#    #No se tiene en cuenta el número de estudiantes que están cursando
#    #ahora para el total de los alumnos
    dataRate.tot = round(dataRate.fail/(dataRate.fail+dataRate.Pass), 2)
    dataRate.fillna(0, inplace=True)
    dataRate = dataRate.drop("fail", 1).drop("Pass", 1)
    dataRate.columns = ['codDegree', 'abandonmentRate']

    data = pd.merge(data, dataRate, how='outer', on=['codDegree'])
    data = data.drop_duplicates()

    data = data[["id", "codDegree", "abandonmentRate", "ultMat", "aniosUltMat2",
                 "aniosEst", "gapSemestres", "yearsNoStudy", "segMat", "terMat",
                 "credDoneRate", "ratePassFinal", "rateFailFinal",
                 "rateCancelFinal", "mediaAPRPTomadas", "mediaAPRPTotal",
                 "mediaPondTotal", "economicFactor", "stateStudent", "dropout"]]

    data.columns = ["id", "degree", "abandonmentRate", "aniosUltMat", "aniosUltMat2",
                "aniosEst", "gapAnios", "yearsNoStudy", 
                "segMat", "terMat", "credDoneRate", "ratePassFinal",
                "rateFailFinal", "rateCancelFinal","mediaAPRPTomadas",
                "mediaAPRPTotal", "mediaPondTotal", "economicFactor" , "stateStudent", "dropout"]


    data = data.fillna(0)
    data = data.sort_values(['degree', 'id'], ascending=[True, True])

    print("Termino final data")
    print(datetime.now() - startTime)
    return data
