"""
Created on Thu Apr  9 01:13:01 2020

@author: estefania.heredia
"""

# -*- coding: utf-8 -*-
from datetime import datetime
import numpy as np

def cambEstudiante(estudiantes):
    """This module preprocess the student data from DB, normalizes and selects the columns to use

    Parameters:
    estudiantes (dataframe): Description of arg1

    Returns:
    df (dataframe): Returning value

    """
    startTime = datetime.now()

    df = estudiantes.copy()

    df.drop("id", 1, inplace=True)
    df['uuid'] = range(1, len(df)+1)

    df = df.drop("paisnacimiento", 1).drop("provincianacimiento", 1).drop("ciudadnacimiento", 1).drop("colegio", 1)
    df = df.drop("paisresidencia", 1).drop("provinciaresidencia", 1).drop("idcarreraactual", 1).drop("nombrecarreraactual", 1).drop("promediopreuniversitario", 1)
    df = df.drop("facultadcarreraactual", 1).drop("semestresinestudiarmax", 1).drop("semestresinestudiarsum", 1).drop("semestressinestudiar", 1)
    df = df.drop("factor_original_value", 1).drop("factor_tipo", 1).drop("factor_final_value", 1)

    df['estadocivil'].replace("CASADO", int(1), inplace=True)
    df['estadocivil'].replace("UNION LIBRE", int(1), inplace=True)
    df['estadocivil'].replace("SOLTERO", int(0), inplace=True)
    df['estadocivil'].replace("VIUDO/A", int(0), inplace=True)

    df['trabaja'].replace("SI", int(1), inplace=True)
    df['trabaja'] = np.where((df.trabaja != 1), int(0), df.trabaja)

    df['ciudadresidencia'].replace("GUAYAQUIL", int(1), inplace=True)
    df['ciudadresidencia'].replace("", int(0), inplace=True)
    df['ciudadresidencia'].fillna(0)
    df['ciudadresidencia'] = np.where((df.ciudadresidencia != 1), int(0), df.ciudadresidencia)

    df['sexo'].replace("MASCULINO", int(1), inplace=True)
    df['sexo'] = np.where((df.sexo != 1), int(0), df.sexo)

    df['tipocolegio'].replace("PARTICULAR", int(1), inplace=True)
    df['tipocolegio'].replace("NACIONAL", int(2), inplace=True)
    df['tipocolegio'].replace("FISCAL", int(2), inplace=True)
    df['tipocolegio'].replace("INSTITUTO", int(2), inplace=True)
    df['tipocolegio'].replace("FISCO MISIONAL", int(2), inplace=True)
    df['tipocolegio'].replace("LICEO", int(1), inplace=True)
    df['tipocolegio'].replace("ACADEMIA", int(1), inplace=True)
    df['tipocolegio'].replace("MUNICIPAL", int(2), inplace=True)
    
    names = ["civil", "work", "schType", "city", "economicFactor", "sex", "codDegree", "totCredits",
             "stateStudent", "matricula", "id"]
    df.columns = names

    print("Termino de obtener a los estudiantes")
    print(datetime.now() - startTime)

    return df
